# Falcosecurity drivers

## Falco Drivers Kernel Testing

This page gives you the latest updates on Falco's kernel driver testing. We test each driver (kmod, bpf, modern_bpf) on various kernels and distributions (which we call the kernel testing matrix). These tests ensure that each driver not only compiles correctly, but also functions and provides the right events to userspace. These tests are super important to make sure Falco keeps working well and adopters can update or change their kernels without any problems. Another positive result for the project maintainers is the increased confidence in releasing new versions of Falco.

To learn more, check out the [Kernel Testing Framework Proposal](https://github.com/falcosecurity/libs/blob/master/proposals/20230530-driver-kernel-testing-framework.md) and visit the official Falco [website](https://falco.org/).

Navigate to the Home of Falco Drivers Kernel Testing on the left, or click this [link](matrix.md).

## Supported Syscalls Report

Navigate to the Home of Falco Drivers Syscalls Report on the left, or click this [link](syscalls.md), or directly proceed to the supported syscalls [report](report.md).

## Perf Continuous Monitoring

Navigate to the Home of Falco Perf Monitoring on the left, or click this [link](perf.md).
